Description

when a qgis project is converted to a mapfile the references to layer attributes are exported as field index instead of field name, eg.

LABELITEM 0 instead of the name of the first field.  Same applies to CLASSITEMs.

AFAICS this cannot be easily fixed, because the project file doesn't contain information about the attribute names.  Maybe that should be

changed anyway as the attributes or their order in the table might change, although the references fields still exists.

Associated revisions

Revision f0f9bd12 - 2007-11-18 01:05 PM - Jürgen Fischer

only store name of layerfield if it's actually set, fixes #814

git-svn-id: http://svn.osgeo.org/qgis/trunk/qgis@7453 c8812cc2-4d05-0410-92ff-de0c093fc19c

Revision 415646af - 2007-11-18 01:05 PM - Jürgen Fischer

only store name of layerfield if it's actually set, fixes #814

git-svn-id: http://svn.osgeo.org/qgis/trunk@7453 c8812cc2-4d05-0410-92ff-de0c093fc19c

History

#1 - 2007-11-17 05:19 PM - Gary Sherman

This requires a change in the [[QgsProject]] code to either:

1. write a separate xml tag containing the actual field name

2. eliminate the use of the field index and use the name instead

Item 1 is probably the simplest at present and wouldn't impact existing project read/write routines.

The mapserver exporter currently has no way to open data sets and retrieve the field information, given we are dealing with file-based and [[PostGIS]] data

stores.

#2 - 2007-11-17 05:37 PM - Jürgen Fischer

- Status changed from Open to In Progress
This doesn't apply to CLASSITEMs as they are written explictly be name.

I'll add a attribute containing the name of the field to the label tag in vector layers and add support for that in the mapexport.

#3 - 2007-11-17 07:47 PM - Jürgen Fischer

- Status changed from In Progress to Closed

- Resolution set to fixed

fixed in commit:2bec93ed (SVN r7449), but the project needs to be resaved before it'll work.

#4 - 2007-11-17 08:36 PM - Gary Sherman

- Status changed from Closed to Feedback

- Resolution deleted (fixed)

This doesn't work. The default label text is being written to the XML rather than the name of the label field. I think the changes may need to be made in

[[QgsLabel]]::writeXML in order to get the correct field name.

#5 - 2007-11-18 06:06 AM - Jürgen Fischer

how does the default label text get exported?

AFAICS [[QgsLabel]]::labelField(Text) either returns the correct fieldname or an empty string.  The empty string case is now covered in commit:415646af

(SVN r7454), although the mapserver export doesn't set empty LABELITEMs anyway.

#6 - 2007-11-18 04:17 PM - Jürgen Fischer

- Resolution set to fixed

- Status changed from Feedback to Closed
